//-----------------------------------------------------Kuchenvariablen-------------------------------------------------------------------------------------
double length;                                             //Länge des Kuchens; wenn 0, dann runder Kuchen
int pieces;                                                //Anzahl der Kuchenstücke die geschnitten werden sollen (sollen gerade sein)                                      
double piecesValue;                                        //Variable für Degree oder cm pro Stück
double height;                                             // hier wird die Größe des Kuchens in cm gespeichert


const int stepperRevolution = 200;                         //Anzahl Schritte des Stepper pro Umdehung
const double oneStep = 0.0175;                             //in cm
const int spinnerS = 02;                                   //Pin für an aus für Dreher
const int spinnerD = 03;                                   //Pin für Richtung für Dreher
const int moverS =  04;                                    //Pin für an aus für mover
const int moverD = 05;                                     //Pin für Richtung für mover
char direction = 'l';                                      //muss nochmal mit pinMode im steup gecheck werden und der Richtung //die Platte fährt raus mit LOW und rein mit HIGH
const double oneDegreeStep = 0.36;                         //360°=1000 Steps --> Übersetzung von Motor zu Zahnrad
const double spinnerRevolution = 1000;                     //steps für volle Umdrehung der runden Platte
int stepCount;                                             //zählt die Schritte die der mover gegangen ist um raus und in die Mitte fahren zu können, Mitte wird vor STart des Programmes manuel festgelgt
int maxSteps = 3.8*stepperRevolution;                      //Anzahl der Umdrehungrn bis die Platte drauße ist

//-----------------------------------------------------IR Variablen--------------------------------------------------------------------------------------------

const int irsensorpin = A0;
const double t = 21.05871719154;
const double A = 1135.059617034;
double ynull = 45.49576002514;
double y = analogRead(irsensorpin);

//-----------------------------------------------------KlingenVariablen-------------------------------------------------------------------------------------

int resistorTolerance = 5;                                //Ungenauigkeit bei den Kontakten
int heightTolerance = 1;                                   //Ungenauigkeit des Abstandsmessers in cm
//int height;                                              //embodies the hight of the Cake
const int posApin = 3;                                     //AnalogRead-Pin um die Position der Klinge zu ermitteln
const int bladeUp = 9;                                     //PWM-Pins für Motor festlegen
const int bladeDown = 10;                                  //pinmodes müssen noch festgelegt werden! (OUTPUT)
const int pwmPin = 11;

int pos1 = 1014;
int pos2 = 931;
int pos3 = 807;
int pos4 = 690;

//-------------------------------------------------------setup-----------------------------------------------------------------------------------------------
void setup() {
 
  Serial.begin(9600);

  //Sensor anschließen
  pinMode(irsensorpin, OUTPUT);

  //Steppermotor für Drehung
  pinMode(spinnerS, OUTPUT);                                //an/aus
  pinMode(spinnerD, OUTPUT);                                //direction
  digitalWrite(spinnerD, HIGH);

  //Steppermotor für vor und zurück
  pinMode(moverS, OUTPUT);                                  //an/aus
  pinMode(moverD, OUTPUT);                                  //direction
  digitalWrite(moverD, LOW);                                //die Platte fährt raus mit LOW unfd rein mit HIGH

  //Gleichstrommotoren anschliessen 
  pinMode(posApin, OUTPUT);                                 //ließt Widerstand des Schleifkontakts
  pinMode(bladeUp, OUTPUT);
  pinMode(bladeDown, OUTPUT);
  digitalWrite(bladeUp, LOW);
  digitalWrite(bladeDown, LOW);
  analogWrite(pwmPin, 255);                                 //setzt den D11-PWM pin auf 255, also volle Leistung! Hier kann die DC-Motorgeschwindigkeit beeinflusst werden

  stepCount=0;                                              //setzt die Variable auf 0 wen die Platte beim, Platte sollte vor Start des Programms in die Mitte gefaren werden, per Hand
}

//----------------------------------------------------loop-----------------------------------------------------------------------------------------------------

void loop() {
   //stepCount=0;                                           // legt die Null fest
   //moveMiddle();                                            //Platte in die Mitte fahren
  
  // NUR AUF PC -------------------hier Foto von ohne Kuchen----------------------------------------------------------------
  
  //Signal von PC
  delay(3000);
  while(Serial.available()==0);
  int notImportant = Serial.read();
  
  
  moveOut();                                                //Platte raus fahren//Funktion in Tap OurStepper definiert, Motor wird in der Methode angesprochen
  moveBladeUp();
  
  while(Serial.available()==0);                             //warte auf Stückzahl
  pieces = Serial.read();                                   //speichert Stückzahl in pieces
  
  //Fehlermeldung bei ungerader Stückzahl?!

  height = getheight();                                     // die Höhe des Kuchens wird gespeichert und gemessen

  //Rückgabe der Entferunung an den PC
  
  moveMiddle();                                             //Funktion im Tap OurStepper definiert, Motor wird in der Funktion angesprochen

  //HÖHE schicken
  Serial.println((String)((int)height));
  
  //NUR AUF PC ------------------------------PC Foto, länge, Art------------------------------------------------

  while(Serial.available()==0);                             //auf Daten Warten
  length = Serial.read();                                   //empfangen und speichern der Kuchenlänge


  //---------------------------------------wenn Kastenkuchen-----------------------------------------------
  if (length != 0){  //Kastenkuchen
    piecesValue = calPieceLength( pieces);                  //kann ich das so mache?!?!
    cutCake();                                              //hier schneiden
    digitalWrite(moverD, LOW);                //lässt die Platte raus fahren (nur Richtung wir eingestellt)
    for(int i=0; i<2; i++){
      for(int j=1; j<pieces/2; j++){
        moveKK();
        cutCake();                            //hier schneiden
      }
      //180° drehen// nur einmal drehen
      if(i==0){
        spin180();                          //Funktion im Tap OurStepper definiert, Motor wird in der Funktion angesprochen
        digitalWrite(moverD, HIGH);         // ändert die Richtung, der Kuchen fährt rein
      }
    }
    moveOut();                              //Funktion im Tap OurStepper definiert, Motor wird in der Funktion angesprochen
    //ende des Programms
  }

//-----------------------------------------wenn runder Kuchen-------------------------------------------------------
  if (length == 0){  //runder Kuchen
    piecesValue = calPieceDegree(pieces);    //kann ich das so machen?
    for(int i=0; i<pieces/2; i++){
      cutCake();                             //hier schneiden
      moveRK();
    }
    moveOut();                               //Funktion im Tap OurStepper definiert, Motor wird in der Funktion angesprochen
    //endeProgramm
  }


  delay(10000);
  moveMiddle();
}

//-----------------------------------Ende Loop-----------------------------------------------------------------------------------


