/*  Gibt ein binäres  Bild als finalImage aus nachdem noch per Knopfdruck ein
    Hintergrund und dann das vergleichsbild aufgenommen wurde
    
    @Threshold ist bei 30
    @finalImg ist das binäre Bild
    TODO:
    Kommunizieren mit dem arduino
    Threshold auf die Umgebung anpassen
    programm ablauf durch While-schleifen bestimmen
    
    
*/


import gab.opencv.*;
import processing.video.*;
import processing.serial.*;

PFont f;
Capture webCam;                                         //Unsere Webcam
OpenCV finalImgcv;                                      //OpenCV für Filter etc.
PImage finalImg;                                        //Das finale bineare Bild
Serial arduino;                                         //Der Arduino
boolean foreGExists = false;                            //Wird true wenn Bildbearbeitung fertig ist
boolean isWaitingForA = false;                          //Wird true wenn Programm auf Arduino wartet
boolean stueckeNotSend = false;                         // wird erst true wenn stuecke erfolgreich eingegeben wurden
int[] cakePixels;                                       //Speichert die linke Kante
int count, cakeLength, stueckzahl, dimension, numOfKeyPressed;    //Verschiedene Ints
Integer hoehe;

void setup(){
  
  size(640, 480);
  f = createFont("SourceCodePro-Regular.ttf", 24);
  textFont(f);
  String[] cams = Capture.list();
  cakePixels = new int[480];
  dimension = 0;
  count = 0;
  hoehe = 0;
  stueckzahl = 0;
  arduino = new Serial(this, "COM4", 9600);
     //  Auskommentieren, wenn webcam nicht mehr erkannt wird 
//  for ( int i = 0; i < cams.length; i++){
//      println(cams[i].toString() + i;
//    }
    
  webCam = new Capture(this, width, height, cams[0], 30); // = name=Vimicro USB2.0 Camrera,size=640x480,fps=30
  webCam.start();
  
  
}

void captureEvent(Capture webCam) {
    webCam.read();
    }

void draw(){
  
  
 // image(webCam, 0, 0);
   // geht erst los, wenn Vordergrund aufgenommen
   if(foreGExists){
     
     save("finalImg");
     
     // Hier wwerden die y-Länge des Kuchens gefunden
     count = getYOfCake();
     println(count);
     // Hier wird geschaut, ob der kuchen eckig oder rund  ist
     if ( !(isCakeRound(count))){
       // Hier wird die Länge des Kuchens ermittelt
       cakeLength = cakeLength();
     } else {
       cakeLength = 0;
     }
     println("Length of cake = " + cakeLength);
     arduino.write(cakeLength);
     
   } else {          //Passiert zu erst
     
     
     // Hier wird der Hintergrund aufgenommen
     if ( finalImgcv == null){
     BackGround();
     println("Hintergrund ist aufgenommen");
     delay(5000);
     arduino.write(10);
     }
     
     //   Hier ist die Stückeingabe
     if ( numOfKeyPressed < 2){
       background(102);
       textAlign(CENTER);
       fill(0);
       text("bitte Stückzahl zwischen 1-99 eigeben", width*0.5 , 95);
       text(stueckzahl + " ", width*0.5, 200);
       println("stückzahl");
       
     }
     // Hier wird das Ergebniss der Stueckzahl eingabe gemacht.
     if ( numOfKeyPressed >= 2){
       if ( stueckzahl%2 == 0){ // grade
        background(102);
        getTextErgebniss(width*0.5);
     } else {                  //ungrade
       stueckzahl = stueckzahl -1;
       background(102);
       getTextErgebniss(width*0.5);
      }
      println("wir waren hier");
      stueckeNotSend = true;
    }
    if(stueckeNotSend){
       // Signal an Arduino
       arduino.write(stueckzahl);
       isWaitingForA = true;
       stueckeNotSend = false;
    }
     
     // Hier wird auf die Höhe gewartet
     while ( isWaitingForA ){
       delay(10);
       // Warten bis die Platform mit kuchen zurückgefahren ist und signal vom Arduino
       if (arduino.available() > 0){
       hoehe = Integer.valueOf(readLineFromSerial(arduino)) ;
       isWaitingForA = false;
       }  
     }
   
     // Hier wird der Kuchen erkennbar gemacht
     if ( hoehe != 0 ){ // hohe = signal vom Arduino
       ForeGround();
     }
     
   }
}

void keyPressed(){
  if ( key >= '0' && key <= '9' && numOfKeyPressed < 2){
    println("a key");
     if ( stueckzahl == 0 && key - 48 != 0 && numOfKeyPressed == 0){
       stueckzahl += (key - 48) * 10;
     } else {
       stueckzahl += key - 48;
     }
     numOfKeyPressed++;
  }
}

void ForeGround(){
    finalImgcv.diff(webCam);
    finalImgcv.threshold(30);
    finalImg = finalImgcv.getSnapshot();
    foreGExists = true;
}

void BackGround(){
  PImage temp = new PImage(640, 480);
  temp.loadPixels();
  temp.pixels = webCam.pixels;
  temp.updatePixels();
  finalImgcv = new OpenCV(this, temp);
  //arduino.write(5747);
}

int getYOfCake(){
  boolean isNotWhite = true;
  dimension = finalImg.width * finalImg.height;
  int yCount = 0;
  
  finalImg.loadPixels();
  
  for ( int i = 0; i < dimension - 22; i++){
    if ( aLineOfColor(i, 0)){
      isNotWhite = true;
    }
    if (isNotWhite){
      
      if ( aLineOfColor(i, 255)){
        isNotWhite = false;
        cakePixels[yCount] = i;
        yCount++;
        
      }
    }
  }
  
  return yCount;
}

boolean isCakeRound(int yCount){
  int maxRound = 450;
  int maxSquare = 300;
  if ( yCount < 5 ) {
    throw new NullPointerException("Cake is smaller than 5 pixels, THATS NO CAKE");
  }
  if ( yCount > maxSquare && yCount < maxRound){
    return true;
  }
  if ( yCount < maxSquare){
   return false; 
  }
  
  throw new NullPointerException("Nothing was done in isCakeRound()");
 
}

int cakeLength(){
  float pixelInCm = 0.043;
  int[] arrayLenghts = new int[10];
  boolean isWhite = true;
  boolean aLongOne = false;
  int countOfWhitePixels = 0;
  int countOfRuns = 0;
  int mittelWert = 0;
  println(cakePixels[(count/2) + 3]);
  println(cakePixels[(count/2) - 3]);
  
  for (int i = cakePixels[(count/2) - 3] ; i < cakePixels[(count/2) + 3]; i++){
   if ( finalImg.pixels[i] == color(255) || finalImg.pixels[i+1] == color(255) || finalImg.pixels[i+2] == color(255) || finalImg.pixels[i+3] == color(255) ||
         finalImg.pixels[i+4] == color(255) || finalImg.pixels[i+5] == color(255) || finalImg.pixels[i+6] == color(255)|| finalImg.pixels[i+15] == color(255)){ // kann man noch besser machen
         
        countOfWhitePixels++;
        if ( finalImg.pixels[i+15] == color(255) && finalImg.pixels[i] == color(0)) aLongOne = true;
        if (isWhite == false) isWhite = true;
    } else {      // if black
      if ( isWhite){ //countOfRuns < 5
        if ( countOfWhitePixels < 50){
          isWhite = false;
        } else { 
          if (aLongOne){
             countOfWhitePixels -= 15; 
          }
          println( countOfRuns + "  " + countOfWhitePixels);
          arrayLenghts[countOfRuns] = countOfWhitePixels;
          countOfRuns++;
          countOfWhitePixels = 0;
          isWhite = false;
        }
      }
    }
  }
  for ( int i = 0; i < countOfRuns; i++){
    mittelWert += arrayLenghts[i];
  }
  // +6, da dass der sicherheits abstand ist
  return (int)((mittelWert/countOfRuns ) * pixelInCm);
  
  
}
//void getStueckzahl(){
  
//  println("Bitte gebe eine Stückzahl zwischen 1-99 ein");
//  while ( numOfKeyPressed < 2){
//    getTextForderung(width*0.5);
//  }
//  if ( stueckzahl%2 == 0){ // grade
//    getTextErgebniss(width*0.5);
//  } else {                  //ungrade
//   stueckzahl = stueckzahl -1;
//   getTextErgebniss(width*0.5);
//  }
  
//}

void getTextErgebniss(float x) {
fill(0);
  text("Ok wir machen dir gerne", x , 95);
  text(stueckzahl + " ", x, 200);
  text("Stücke", x, 305);
}

String  readLineFromSerial(Serial  port) {
  byte temp[] = port.readBytesUntil('\n'); //read data from buffer until a new line is finished
 
  // check if any data is available
  if (temp == null) {
    return null; //got nothing - return an empty array
  }   
  else {
    String inBuffer= new String(temp);
    inBuffer=trim(inBuffer);//convert raw data to a string
    return inBuffer;
  }
}

boolean aLineOfColor(int pixel, int blackOrWhite){
 int count = 0;
 int lengthOfPixels = 20;
 for ( int i = pixel; i < lengthOfPixels + pixel; i++){
   if ( finalImg.pixels[i] == color(blackOrWhite)){
     count++;
   }
 }
 if (count == lengthOfPixels){
   return true;
 } else {
   return false;
 }
}